
#include <iostream.h>
#include <iomanip.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

enum Logical  { FALSE, TRUE };
enum ExitCode { SUCCESS, HEAP_ERR, ARG_ERR, INPUT_ERR, };

const int  MAXLEN   =    80;
const int  MINLEN   =     3;
const int  FNAME    =    13;
const char EOS      =  '\0';
const char EOL      =  '\n';
const char SPACE    =   ' ';
const char EXTASC   =   '';   // start of upper ascii set

#define VIEWABLE(c)     (((c) & EXTASC) || (SPACE > (c)))
#define LAST_CHAR(str)  (str)[strlen((str)) - 1]
#define PRINT(s)        cout << (s) << endl

static void *Kalloc(unsigned int nbytes, char filChar = EOS);
static void PrintStr(char *p, int min, int n);

/////////////////////////////////////////////////////////////////////////
 
void main(int argc, char **argv)
{
   FILE *fp;
   Logical flag = FALSE;
   int count = 0;
   int c,
       minlen = MINLEN,
       maxlen = MAXLEN;
 
   if (argc < 2)
   {
           cerr << "\n   Usage: scanner  <filespec> [minlen] [maxlen]\n"
                << "\n        filespec:  file you want to scan"
                << "\n          minlen:  minimum viewable characters (default = 3)"
                << "\n          maxlen:  maximum characters per line (default = 80)"
                << endl;

           exit(ARG_ERR);
   }
 
   if ((fp = fopen(argv[1], "rb")) == NULL)
   {
       cerr << "\n   SCANNER  Can not open input file " << argv[1] << "\n" << endl;
       exit(INPUT_ERR);
   }

   if (argc >= 3)
   {
        minlen = atoi(argv[2]);

        if (minlen == 0 || minlen > 80)
               { minlen = 3; }

        if (argc == 4)
        {
           maxlen = atoi(argv[3]);

           if (maxlen == 0 || maxlen > 255)
                  { maxlen = 80; } 
        }
   }

   char *buffer = (char *) Kalloc(maxlen);

   while ((c = getc(fp)) != EOF)
   {
       if (VIEWABLE(c))              // check for non viewing characters
       {
               flag = TRUE;
               continue;
       }
       
       if (flag)
       {
               PrintStr(buffer, minlen, count);
               count = 0;
               flag  = FALSE;
       }

       if (count == maxlen)
       {
               PrintStr(buffer, minlen, count);
               count = 0;
       }

       buffer[count++] = c;           // build string
   }

   PrintStr(buffer, minlen, count);
   
   fclose(fp);
   delete buffer;
   exit(SUCCESS);
}


static void PrintStr(char *p, int min, int n)
{
   p[n]  = EOS;      // make string

   if (strlen(p) >= min)
   {
        if (LAST_CHAR(p) == SPACE)
            LAST_CHAR(p) = '';

        PRINT(p);   // output line
   }
}


// allocate space and return pointer
// you can also fill the object with any character
static void *Kalloc(unsigned int nbytes, char filChar)
{
   char *p = new char [nbytes];

   // if not enough memory then exit to DOS
   if(!p)
   {
       cerr << "\n   All heaped out" << "\n" << endl;
       exit(HEAP_ERR);
   }

   for(int k = 0; k < nbytes; k++)
         { p[k] = filChar; }

   p[--k] = EOS;  // backup to last byte in object

   return p; 
}
